/[gentoo-x86]/eclass/distutils.eclass
Gentoo

Diff of /eclass/distutils.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.67 Revision 1.73
1# Copyright 1999-2009 Gentoo Foundation 1# Copyright 1999-2010 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/distutils.eclass,v 1.67 2009/11/28 18:39:27 arfrever Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/distutils.eclass,v 1.73 2010/02/28 11:52:22 arfrever Exp $
4 4
5# @ECLASS: distutils.eclass 5# @ECLASS: distutils.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# <python@gentoo.org> 7# Gentoo Python Project <python@gentoo.org>
8# 8#
9# Original author: Jon Nelson <jnelson@gentoo.org> 9# Original author: Jon Nelson <jnelson@gentoo.org>
10# @BLURB: This eclass allows easier installation of distutils-based python modules 10# @BLURB: Eclass for packages with build systems using Distutils
11# @DESCRIPTION: 11# @DESCRIPTION:
12# The distutils eclass is designed to allow easier installation of 12# The distutils eclass defines phase functions for packages with build systems using Distutils.
13# distutils-based python modules and their incorporation into
14# the Gentoo Linux system.
15 13
16inherit eutils multilib python 14inherit multilib python
17 15
18case "${EAPI:-0}" in 16case "${EAPI:-0}" in
19 0|1) 17 0|1)
20 EXPORT_FUNCTIONS src_unpack src_compile src_install pkg_postinst pkg_postrm 18 EXPORT_FUNCTIONS src_unpack src_compile src_install pkg_postinst pkg_postrm
21 ;; 19 ;;
22 *) 20 *)
23 EXPORT_FUNCTIONS src_unpack src_prepare src_compile src_install pkg_postinst pkg_postrm 21 EXPORT_FUNCTIONS src_prepare src_compile src_install pkg_postinst pkg_postrm
24 ;; 22 ;;
25esac 23esac
26 24
27if [[ -z "${DISTUTILS_DISABLE_PYTHON_DEPENDENCY}" ]]; then 25if [[ -z "${PYTHON_DEPEND}" ]]; then
28 DEPEND="virtual/python" 26 DEPEND="dev-lang/python"
29 RDEPEND="${DEPEND}" 27 RDEPEND="${DEPEND}"
30fi 28fi
29
30if has "${EAPI:-0}" 0 1 2 && [[ -z "${SUPPORT_PYTHON_ABIS}" ]]; then
31python="python" 31 python="python"
32else
33 # Use "$(PYTHON)" instead of "${python}".
34 python="die"
35fi
32 36
33# @ECLASS-VARIABLE: DISTUTILS_USE_SEPARATE_SOURCE_DIRECTORIES 37# @ECLASS-VARIABLE: DISTUTILS_USE_SEPARATE_SOURCE_DIRECTORIES
34# @DESCRIPTION: 38# @DESCRIPTION:
35# Set this to use separate source directories for each enabled version of Python. 39# Set this to use separate source directories for each enabled version of Python.
36 40
37# @ECLASS-VARIABLE: DISTUTILS_GLOBAL_OPTIONS 41# @ECLASS-VARIABLE: DISTUTILS_GLOBAL_OPTIONS
38# @DESCRIPTION: 42# @DESCRIPTION:
39# Global options passed to setup.py. 43# Global options passed to setup.py.
40 44
45# @ECLASS-VARIABLE: DISTUTILS_SRC_TEST
46# @DESCRIPTION:
47# Type of test command used by distutils_src_test().
48# IUSE and DEPEND are automatically adjusted, unless DISTUTILS_DISABLE_TEST_DEPENDENCY is set.
49# Valid values:
50# setup.py
51# nosetests
52# py.test
53# trial [arguments]
54
55# @ECLASS-VARIABLE: DISTUTILS_DISABLE_TEST_DEPENDENCY
56# @DESCRIPTION:
57# Disable modification of IUSE and DEPEND caused by setting of DISTUTILS_SRC_TEST.
58
59if [[ -n "${DISTUTILS_SRC_TEST}" && ! "${DISTUTILS_SRC_TEST}" =~ ^(setup\.py|nosetests|py\.test|trial(\ .*)?)$ ]]; then
60 die "'DISTUTILS_SRC_TEST' variable has unsupported value '${DISTUTILS_SRC_TEST}'"
61fi
62
63if [[ -z "${DISTUTILS_DISABLE_TEST_DEPENDENCY}" ]]; then
64 if [[ "${DISTUTILS_SRC_TEST}" == "nosetests" ]]; then
65 IUSE="test"
66 DEPEND+="${DEPEND:+ }test? ( dev-python/nose )"
67 elif [[ "${DISTUTILS_SRC_TEST}" == "py.test" ]]; then
68 IUSE="test"
69 DEPEND+="${DEPEND:+ }test? ( dev-python/py )"
70 # trial requires an argument, which is usually equal to "${PN}".
71 elif [[ "${DISTUTILS_SRC_TEST}" =~ ^trial(\ .*)?$ ]]; then
72 IUSE="test"
73 DEPEND+="${DEPEND:+ }test? ( dev-python/twisted )"
74 fi
75fi
76
77if [[ -n "${DISTUTILS_SRC_TEST}" ]]; then
78 EXPORT_FUNCTIONS src_test
79fi
80
81# @ECLASS-VARIABLE: DISTUTILS_DISABLE_VERSIONING_OF_PYTHON_SCRIPTS
82# @DESCRIPTION:
83# Set this to disable renaming of Python scripts containing versioned shebangs
84# and generation of wrapper scripts.
85
86# @ECLASS-VARIABLE: DISTUTILS_NONVERSIONED_PYTHON_SCRIPTS
87# @DESCRIPTION:
88# List of paths to Python scripts, relative to ${D}, which are excluded from
89# renaming and generation of wrapper scripts.
90
41# @ECLASS-VARIABLE: DOCS 91# @ECLASS-VARIABLE: DOCS
42# @DESCRIPTION: 92# @DESCRIPTION:
43# Additional DOCS 93# Additional documentation files installed by distutils_src_install().
94
95_distutils_get_build_dir() {
96 if [[ -n "${SUPPORT_PYTHON_ABIS}" && -z "${DISTUTILS_USE_SEPARATE_SOURCE_DIRECTORIES}" ]]; then
97 echo "build-${PYTHON_ABI}"
98 else
99 echo "build"
100 fi
101}
102
103_distutils_get_PYTHONPATH() {
104 if [[ -n "${SUPPORT_PYTHON_ABIS}" && -z "${DISTUTILS_USE_SEPARATE_SOURCE_DIRECTORIES}" ]]; then
105 ls -d build-${PYTHON_ABI}/lib* 2> /dev/null
106 else
107 ls -d build/lib* 2> /dev/null
108 fi
109}
44 110
45_distutils_hook() { 111_distutils_hook() {
46 if [[ "$#" -ne 1 ]]; then 112 if [[ "$#" -ne 1 ]]; then
47 die "${FUNCNAME}() requires 1 argument" 113 die "${FUNCNAME}() requires 1 argument"
48 fi 114 fi
51 fi 117 fi
52} 118}
53 119
54# @FUNCTION: distutils_src_unpack 120# @FUNCTION: distutils_src_unpack
55# @DESCRIPTION: 121# @DESCRIPTION:
56# The distutils src_unpack function, this function is exported. 122# The distutils src_unpack function. This function is exported.
57distutils_src_unpack() { 123distutils_src_unpack() {
124 if ! has "${EAPI:-0}" 0 1; then
125 die "${FUNCNAME}() cannot be used in this EAPI"
126 fi
127
58 if [[ "${EBUILD_PHASE}" != "unpack" ]]; then 128 if [[ "${EBUILD_PHASE}" != "unpack" ]]; then
59 die "${FUNCNAME}() can be used only in src_unpack() phase" 129 die "${FUNCNAME}() can be used only in src_unpack() phase"
60 fi 130 fi
61 131
62 unpack ${A} 132 unpack ${A}
63 cd "${S}" 133 cd "${S}"
64 134
65 has "${EAPI:-0}" 0 1 && distutils_src_prepare 135 distutils_src_prepare
66} 136}
67 137
68# @FUNCTION: distutils_src_prepare 138# @FUNCTION: distutils_src_prepare
69# @DESCRIPTION: 139# @DESCRIPTION:
70# The distutils src_prepare function, this function is exported. 140# The distutils src_prepare function. This function is exported.
71distutils_src_prepare() { 141distutils_src_prepare() {
72 if ! has "${EAPI:-0}" 0 1 && [[ "${EBUILD_PHASE}" != "prepare" ]]; then 142 if ! has "${EAPI:-0}" 0 1 && [[ "${EBUILD_PHASE}" != "prepare" ]]; then
73 die "${FUNCNAME}() can be used only in src_prepare() phase" 143 die "${FUNCNAME}() can be used only in src_prepare() phase"
74 fi 144 fi
75 145
76 # Delete ez_setup files to prevent packages from installing 146 # Delete ez_setup files to prevent packages from installing Setuptools on their own.
77 # Setuptools on their own.
78 local ez_setup_existence="0" 147 local ez_setup_existence="0"
79 [[ -d ez_setup || -f ez_setup.py ]] && ez_setup_existence="1" 148 [[ -d ez_setup || -f ez_setup.py ]] && ez_setup_existence="1"
80 rm -fr ez_setup* 149 rm -fr ez_setup*
81 if [[ "${ez_setup_existence}" == "1" ]]; then 150 if [[ "${ez_setup_existence}" == "1" ]]; then
82 echo "def use_setuptools(*args, **kwargs): pass" > ez_setup.py 151 echo "def use_setuptools(*args, **kwargs): pass" > ez_setup.py
83 fi 152 fi
84 153
85 # Delete distribute_setup files to prevent packages from installing 154 # Delete distribute_setup files to prevent packages from installing Distribute on their own.
86 # Distribute on their own.
87 local distribute_setup_existence="0" 155 local distribute_setup_existence="0"
88 [[ -d distribute_setup || -f distribute_setup.py ]] && distribute_setup_existence="1" 156 [[ -d distribute_setup || -f distribute_setup.py ]] && distribute_setup_existence="1"
89 rm -fr distribute_setup* 157 rm -fr distribute_setup*
90 if [[ "${distribute_setup_existence}" == "1" ]]; then 158 if [[ "${distribute_setup_existence}" == "1" ]]; then
91 echo "def use_setuptools(*args, **kwargs): pass" > distribute_setup.py 159 echo "def use_setuptools(*args, **kwargs): pass" > distribute_setup.py
96 fi 164 fi
97} 165}
98 166
99# @FUNCTION: distutils_src_compile 167# @FUNCTION: distutils_src_compile
100# @DESCRIPTION: 168# @DESCRIPTION:
101# The distutils src_compile function, this function is exported. 169# The distutils src_compile function. This function is exported.
102# In newer EAPIs this function calls distutils_src_compile_pre_hook() and 170# In ebuilds of packages supporting installation for multiple versions of Python, this function
103# distutils_src_compile_post_hook(), if they are defined. 171# calls distutils_src_compile_pre_hook() and distutils_src_compile_post_hook(), if they are defined.
104distutils_src_compile() { 172distutils_src_compile() {
105 if [[ "${EBUILD_PHASE}" != "compile" ]]; then 173 if [[ "${EBUILD_PHASE}" != "compile" ]]; then
106 die "${FUNCNAME}() can be used only in src_compile() phase" 174 die "${FUNCNAME}() can be used only in src_compile() phase"
107 fi 175 fi
108 176
177 _python_set_color_variables
178
109 if ! has "${EAPI:-0}" 0 1 2 || [[ -n "${SUPPORT_PYTHON_ABIS}" ]]; then 179 if [[ -n "${SUPPORT_PYTHON_ABIS}" ]]; then
110 if [[ -n "${DISTUTILS_USE_SEPARATE_SOURCE_DIRECTORIES}" ]]; then 180 distutils_building() {
111 building() {
112 _distutils_hook pre 181 _distutils_hook pre
113 182
114 echo "$(PYTHON)" setup.py "${DISTUTILS_GLOBAL_OPTIONS[@]}" build "$@" 183 echo ${_BOLD}"$(PYTHON)" setup.py "${DISTUTILS_GLOBAL_OPTIONS[@]}" build -b "$(_distutils_get_build_dir)" "$@"${_NORMAL}
115 "$(PYTHON)" setup.py "${DISTUTILS_GLOBAL_OPTIONS[@]}" build "$@" || return "$?" 184 "$(PYTHON)" setup.py "${DISTUTILS_GLOBAL_OPTIONS[@]}" build -b "$(_distutils_get_build_dir)" "$@" || return "$?"
116 185
117 _distutils_hook post 186 _distutils_hook post
187 }
188 python_execute_function ${DISTUTILS_USE_SEPARATE_SOURCE_DIRECTORIES:+-s} distutils_building "$@"
189 else
190 echo ${_BOLD}"$(PYTHON)" setup.py "${DISTUTILS_GLOBAL_OPTIONS[@]}" build "$@"${_NORMAL}
191 "$(PYTHON)" setup.py "${DISTUTILS_GLOBAL_OPTIONS[@]}" build "$@" || die "Building failed"
192 fi
193}
194
195# @FUNCTION: distutils_src_test
196# @DESCRIPTION:
197# The distutils src_test function. This function is exported, when DISTUTILS_SRC_TEST variable is set.
198distutils_src_test() {
199 _python_set_color_variables
200
201 if [[ "${DISTUTILS_SRC_TEST}" == "setup.py" ]]; then
202 if [[ -n "${SUPPORT_PYTHON_ABIS}" ]]; then
203 distutils_testing() {
204 echo ${_BOLD}PYTHONPATH="$(_distutils_get_PYTHONPATH)" "$(PYTHON)" setup.py "${DISTUTILS_GLOBAL_OPTIONS[@]}" $([[ -z "${DISTUTILS_USE_SEPARATE_SOURCE_DIRECTORIES}" ]] && echo build -b "$(_distutils_get_build_dir)") test "$@"${_NORMAL}
205 PYTHONPATH="$(_distutils_get_PYTHONPATH)" "$(PYTHON)" setup.py "${DISTUTILS_GLOBAL_OPTIONS[@]}" $([[ -z "${DISTUTILS_USE_SEPARATE_SOURCE_DIRECTORIES}" ]] && echo build -b "$(_distutils_get_build_dir)") test "$@"
118 } 206 }
119 python_execute_function -s building "$@" 207 python_execute_function ${DISTUTILS_USE_SEPARATE_SOURCE_DIRECTORIES:+-s} distutils_testing "$@"
120 else 208 else
121 building() { 209 echo ${_BOLD}PYTHONPATH="$(_distutils_get_PYTHONPATH)" "$(PYTHON)" setup.py "${DISTUTILS_GLOBAL_OPTIONS[@]}" test "$@"${_NORMAL}
122 _distutils_hook pre 210 PYTHONPATH="$(_distutils_get_PYTHONPATH)" "$(PYTHON)" setup.py "${DISTUTILS_GLOBAL_OPTIONS[@]}" test "$@" || die "Testing failed"
123
124 echo "$(PYTHON)" setup.py "${DISTUTILS_GLOBAL_OPTIONS[@]}" build -b "build-${PYTHON_ABI}" "$@"
125 "$(PYTHON)" setup.py "${DISTUTILS_GLOBAL_OPTIONS[@]}" build -b "build-${PYTHON_ABI}" "$@" || return "$?"
126
127 _distutils_hook post
128 }
129 python_execute_function building "$@"
130 fi 211 fi
212 elif [[ "${DISTUTILS_SRC_TEST}" == "nosetests" ]]; then
213 python_execute_nosetests -P '$(_distutils_get_PYTHONPATH)' ${DISTUTILS_USE_SEPARATE_SOURCE_DIRECTORIES:+-s} -- "$@"
214 elif [[ "${DISTUTILS_SRC_TEST}" == "py.test" ]]; then
215 python_execute_py.test -P '$(_distutils_get_PYTHONPATH)' ${DISTUTILS_USE_SEPARATE_SOURCE_DIRECTORIES:+-s} -- "$@"
216 # trial requires an argument, which is usually equal to "${PN}".
217 elif [[ "${DISTUTILS_SRC_TEST}" =~ ^trial(\ .*)?$ ]]; then
218 local trial_arguments
219 if [[ "${DISTUTILS_SRC_TEST}" == "trial "* ]]; then
220 trial_arguments="${DISTUTILS_SRC_TEST#trial }"
131 else 221 else
132 python_version 222 trial_arguments="${PN}"
133 echo "$(PYTHON "${PYVER}")" setup.py "${DISTUTILS_GLOBAL_OPTIONS[@]}" build "$@" 223 fi
134 "$(PYTHON "${PYVER}")" setup.py "${DISTUTILS_GLOBAL_OPTIONS[@]}" build "$@" || die "Building failed" 224
225 python_execute_trial -P '$(_distutils_get_PYTHONPATH)' ${DISTUTILS_USE_SEPARATE_SOURCE_DIRECTORIES:+-s} -- ${trial_arguments} "$@"
226 else
227 die "'DISTUTILS_SRC_TEST' variable has unsupported value '${DISTUTILS_SRC_TEST}'"
135 fi 228 fi
136} 229}
137 230
138# @FUNCTION: distutils_src_install 231# @FUNCTION: distutils_src_install
139# @DESCRIPTION: 232# @DESCRIPTION:
140# The distutils src_install function, this function is exported. 233# The distutils src_install function. This function is exported.
141# In newer EAPIs this function calls distutils_src_install_pre_hook() and 234# In ebuilds of packages supporting installation for multiple versions of Python, this function
142# distutils_src_install_post_hook(), if they are defined. 235# calls distutils_src_install_pre_hook() and distutils_src_install_post_hook(), if they are defined.
143# It also installs the "standard docs" (CHANGELOG, Change*, KNOWN_BUGS, MAINTAINERS, 236# It also installs some standard documentation files (AUTHORS, Change*, CHANGELOG, CONTRIBUTORS,
144# PKG-INFO, CONTRIBUTORS, TODO, NEWS, MANIFEST*, README*, and AUTHORS) 237# KNOWN_BUGS, MAINTAINERS, MANIFEST*, NEWS, PKG-INFO, README*, TODO).
145distutils_src_install() { 238distutils_src_install() {
146 if [[ "${EBUILD_PHASE}" != "install" ]]; then 239 if [[ "${EBUILD_PHASE}" != "install" ]]; then
147 die "${FUNCNAME}() can be used only in src_install() phase" 240 die "${FUNCNAME}() can be used only in src_install() phase"
148 fi 241 fi
149 242
150 local pylibdir 243 _python_set_color_variables
151 244
152 # Mark the package to be rebuilt after a python upgrade.
153 python_need_rebuild
154
155 if ! has "${EAPI:-0}" 0 1 2 || [[ -n "${SUPPORT_PYTHON_ABIS}" ]]; then 245 if [[ -n "${SUPPORT_PYTHON_ABIS}" ]]; then
156 if [[ -n "${DISTUTILS_USE_SEPARATE_SOURCE_DIRECTORIES}" ]]; then 246 if [[ -z "${DISTUTILS_DISABLE_VERSIONING_OF_PYTHON_SCRIPTS}" && "${BASH_VERSINFO[0]}" -ge 4 ]]; then
157 installation() { 247 declare -A wrapper_scripts=()
158 _distutils_hook pre
159 248
160 # need this for python-2.5 + setuptools in cases where 249 rename_scripts_with_versioned_shebangs() {
161 # a package uses distutils but does not install anything 250 if [[ -d "${D}usr/bin" ]]; then
162 # in site-packages. (eg. dev-java/java-config-2.x) 251 cd "${D}usr/bin"
163 # - liquidx (14/08/2006)
164 pylibdir="$("$(PYTHON)" -c 'from distutils.sysconfig import get_python_lib; print(get_python_lib())')"
165 [[ -n "${pylibdir}" ]] && dodir "${pylibdir}"
166 252
167 echo "$(PYTHON)" setup.py "${DISTUTILS_GLOBAL_OPTIONS[@]}" install --root="${D}" --no-compile "$@" 253 local nonversioned_file file
168 "$(PYTHON)" setup.py "${DISTUTILS_GLOBAL_OPTIONS[@]}" install --root="${D}" --no-compile "$@" || return "$?" 254 for file in *; do
169 255 if [[ -f "${file}" && ! "${file}" =~ [[:digit:]]+\.[[:digit:]](-jython)?+$ && "$(head -n1 "${file}")" =~ ^'#!'.*(python|jython-)[[:digit:]]+\.[[:digit:]]+ ]]; then
170 _distutils_hook post 256 for nonversioned_file in "${DISTUTILS_NONVERSIONED_PYTHON_SCRIPTS[@]}"; do
257 [[ "${nonversioned_file}" == "/usr/bin/${file}" ]] && continue 2
258 done
259 mv "${file}" "${file}-${PYTHON_ABI}" || die "Renaming of '${file}' failed"
260 wrapper_scripts+=(["${D}usr/bin/${file}"]=)
261 fi
262 done
263 fi
171 } 264 }
172 python_execute_function -s installation "$@" 265 fi
173 else 266
174 installation() { 267 distutils_installation() {
175 _distutils_hook pre 268 _distutils_hook pre
176 269
177 # need this for python-2.5 + setuptools in cases where 270 echo ${_BOLD}"$(PYTHON)" setup.py "${DISTUTILS_GLOBAL_OPTIONS[@]}" $([[ -z "${DISTUTILS_USE_SEPARATE_SOURCE_DIRECTORIES}" ]] && echo build -b "$(_distutils_get_build_dir)") install --root="${D}" --no-compile "$@"${_NORMAL}
178 # a package uses distutils but does not install anything 271 "$(PYTHON)" setup.py "${DISTUTILS_GLOBAL_OPTIONS[@]}" $([[ -z "${DISTUTILS_USE_SEPARATE_SOURCE_DIRECTORIES}" ]] && echo build -b "$(_distutils_get_build_dir)") install --root="${D}" --no-compile "$@" || return "$?"
179 # in site-packages. (eg. dev-java/java-config-2.x)
180 # - liquidx (14/08/2006)
181 pylibdir="$("$(PYTHON)" -c 'from distutils.sysconfig import get_python_lib; print(get_python_lib())')"
182 [[ -n "${pylibdir}" ]] && dodir "${pylibdir}"
183 272
184 echo "$(PYTHON)" setup.py "${DISTUTILS_GLOBAL_OPTIONS[@]}" build -b "build-${PYTHON_ABI}" install --root="${D}" --no-compile "$@" 273 if [[ -z "${DISTUTILS_DISABLE_VERSIONING_OF_PYTHON_SCRIPTS}" && "${BASH_VERSINFO[0]}" -ge 4 ]]; then
185 "$(PYTHON)" setup.py "${DISTUTILS_GLOBAL_OPTIONS[@]}" build -b "build-${PYTHON_ABI}" install --root="${D}" --no-compile "$@" || return "$?" 274 rename_scripts_with_versioned_shebangs
275 fi
186 276
187 _distutils_hook post 277 _distutils_hook post
188 } 278 }
189 python_execute_function installation "$@" 279 python_execute_function ${DISTUTILS_USE_SEPARATE_SOURCE_DIRECTORIES:+-s} distutils_installation "$@"
190 fi
191 else
192 # need this for python-2.5 + setuptools in cases where
193 # a package uses distutils but does not install anything
194 # in site-packages. (eg. dev-java/java-config-2.x)
195 # - liquidx (14/08/2006)
196 pylibdir="$("$(PYTHON "${PYVER}")" -c 'from distutils.sysconfig import get_python_lib; print(get_python_lib())')"
197 [[ -n "${pylibdir}" ]] && dodir "${pylibdir}"
198 280
281 if [[ -z "${DISTUTILS_DISABLE_VERSIONING_OF_PYTHON_SCRIPTS}" && "${#wrapper_scripts[@]}" -ne 0 && "${BASH_VERSINFO[0]}" -ge 4 ]]; then
282 python_generate_wrapper_scripts "${!wrapper_scripts[@]}"
283 fi
284 unset wrapper_scripts
285 else
286 # Mark the package to be rebuilt after a Python upgrade.
287 python_need_rebuild
288
199 echo "$(PYTHON "${PYVER}")" setup.py "${DISTUTILS_GLOBAL_OPTIONS[@]}" install --root="${D}" --no-compile "$@" 289 echo ${_BOLD}"$(PYTHON)" setup.py "${DISTUTILS_GLOBAL_OPTIONS[@]}" install --root="${D}" --no-compile "$@"${_NORMAL}
200 "$(PYTHON "${PYVER}")" setup.py "${DISTUTILS_GLOBAL_OPTIONS[@]}" install --root="${D}" --no-compile "$@" || die "Installation failed" 290 "$(PYTHON)" setup.py "${DISTUTILS_GLOBAL_OPTIONS[@]}" install --root="${D}" --no-compile "$@" || die "Installation failed"
201 fi 291 fi
202 292
203 if [[ -e "${D}usr/local" ]]; then 293 if [[ -e "${D}usr/local" ]]; then
204 die "Illegal installation into /usr/local" 294 die "Illegal installation into /usr/local"
205 fi 295 fi
217 fi 307 fi
218} 308}
219 309
220# @FUNCTION: distutils_pkg_postinst 310# @FUNCTION: distutils_pkg_postinst
221# @DESCRIPTION: 311# @DESCRIPTION:
222# This is a generic optimization, you should override it if your package 312# The distutils pkg_postinst function. This function is exported.
223# installs modules in another directory. This function is exported. 313# When PYTHON_MODNAME variable is set, then this function calls python_mod_optimize() with modules
314# specified in PYTHON_MODNAME variable. Otherwise it calls python_mod_optimize() with module, whose
315# name is equal to name of current package, if this module exists.
224distutils_pkg_postinst() { 316distutils_pkg_postinst() {
225 if [[ "${EBUILD_PHASE}" != "postinst" ]]; then 317 if [[ "${EBUILD_PHASE}" != "postinst" ]]; then
226 die "${FUNCNAME}() can be used only in pkg_postinst() phase" 318 die "${FUNCNAME}() can be used only in pkg_postinst() phase"
227 fi 319 fi
228 320
229 local pylibdir pymod 321 local pylibdir pymod
230 if [[ -z "${PYTHON_MODNAME}" ]]; then 322 if [[ -z "${PYTHON_MODNAME}" ]]; then
231 for pylibdir in "${ROOT}"/usr/$(get_libdir)/python*; do 323 for pylibdir in "${ROOT}"usr/$(get_libdir)/python* "${ROOT}"/usr/share/jython-*/Lib; do
232 if [[ -d "${pylibdir}/site-packages/${PN}" ]]; then 324 if [[ -d "${pylibdir}/site-packages/${PN}" ]]; then
233 PYTHON_MODNAME="${PN}" 325 PYTHON_MODNAME="${PN}"
234 fi 326 fi
235 done 327 done
236 fi 328 fi
244 fi 336 fi
245} 337}
246 338
247# @FUNCTION: distutils_pkg_postrm 339# @FUNCTION: distutils_pkg_postrm
248# @DESCRIPTION: 340# @DESCRIPTION:
249# Generic pyc/pyo cleanup script. This function is exported. 341# The distutils pkg_postrm function. This function is exported.
342# When PYTHON_MODNAME variable is set, then this function calls python_mod_cleanup() with modules
343# specified in PYTHON_MODNAME variable. Otherwise it calls python_mod_cleanup() with module, whose
344# name is equal to name of current package, if this module exists.
250distutils_pkg_postrm() { 345distutils_pkg_postrm() {
251 if [[ "${EBUILD_PHASE}" != "postrm" ]]; then 346 if [[ "${EBUILD_PHASE}" != "postrm" ]]; then
252 die "${FUNCNAME}() can be used only in pkg_postrm() phase" 347 die "${FUNCNAME}() can be used only in pkg_postrm() phase"
253 fi 348 fi
254 349
255 local pylibdir pymod 350 local pylibdir pymod
256 if [[ -z "${PYTHON_MODNAME}" ]]; then 351 if [[ -z "${PYTHON_MODNAME}" ]]; then
257 for pylibdir in "${ROOT}"/usr/$(get_libdir)/python*; do 352 for pylibdir in "${ROOT}"usr/$(get_libdir)/python* "${ROOT}"/usr/share/jython-*/Lib; do
258 if [[ -d "${pylibdir}/site-packages/${PN}" ]]; then 353 if [[ -d "${pylibdir}/site-packages/${PN}" ]]; then
259 PYTHON_MODNAME="${PN}" 354 PYTHON_MODNAME="${PN}"
260 fi 355 fi
261 done 356 done
262 fi 357 fi
264 if [[ -n "${PYTHON_MODNAME}" ]]; then 359 if [[ -n "${PYTHON_MODNAME}" ]]; then
265 if ! has "${EAPI:-0}" 0 1 2 || [[ -n "${SUPPORT_PYTHON_ABIS}" ]]; then 360 if ! has "${EAPI:-0}" 0 1 2 || [[ -n "${SUPPORT_PYTHON_ABIS}" ]]; then
266 python_mod_cleanup ${PYTHON_MODNAME} 361 python_mod_cleanup ${PYTHON_MODNAME}
267 else 362 else
268 for pymod in ${PYTHON_MODNAME}; do 363 for pymod in ${PYTHON_MODNAME}; do
269 for pylibdir in "${ROOT}"/usr/$(get_libdir)/python*; do 364 for pylibdir in "${ROOT}"usr/$(get_libdir)/python*; do
270 if [[ -d "${pylibdir}/site-packages/${pymod}" ]]; then 365 if [[ -d "${pylibdir}/site-packages/${pymod}" ]]; then
271 python_mod_cleanup "${pylibdir#${ROOT}}/site-packages/${pymod}" 366 python_mod_cleanup "${pylibdir#${ROOT%/}}/site-packages/${pymod}"
272 fi 367 fi
273 done 368 done
274 done 369 done
275 fi 370 fi
276 else 371 else
278 fi 373 fi
279} 374}
280 375
281# @FUNCTION: distutils_python_version 376# @FUNCTION: distutils_python_version
282# @DESCRIPTION: 377# @DESCRIPTION:
283# Calls python_version, so that you can use something like 378# Deprecated wrapper function for deprecated python_version().
284# e.g. insinto ${ROOT}/usr/include/python${PYVER}
285distutils_python_version() { 379distutils_python_version() {
380 if ! has "${EAPI:-0}" 0 1 2 || [[ -n "${SUPPORT_PYTHON_ABIS}" ]]; then
381 eerror "Use PYTHON() and/or python_get_*() instead of ${FUNCNAME}()."
382 die "${FUNCNAME}() cannot be used in this EAPI"
383 fi
384
286 python_version 385 python_version
287} 386}
288 387
289# @FUNCTION: distutils_python_tkinter 388# @FUNCTION: distutils_python_tkinter
290# @DESCRIPTION: 389# @DESCRIPTION:
291# Checks for if tkinter support is compiled into python 390# Deprecated wrapper function for deprecated python_tkinter_exists().
292distutils_python_tkinter() { 391distutils_python_tkinter() {
392 if ! has "${EAPI:-0}" 0 1 2 || [[ -n "${SUPPORT_PYTHON_ABIS}" ]]; then
393 eerror "Use PYTHON_USE_WITH=\"xml\" and python_pkg_setup() instead of ${FUNCNAME}()."
394 die "${FUNCNAME}() cannot be used in this EAPI"
395 fi
396
293 python_tkinter_exists 397 python_tkinter_exists
294} 398}

Legend:
Removed from v.1.67  
changed lines
  Added in v.1.73

  ViewVC Help
Powered by ViewVC 1.1.20